diff -ruN qmail-1.03-orig/qmail-inject.c qmail-1.03-ldap-20060201-orig/qmail-inject.c
--- qmail-1.03-orig/qmail-inject.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-inject.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "sig.h"
 #include "substdio.h"
 #include "stralloc.h"
@@ -35,10 +36,10 @@
 int flaghackmess = 0;
 int flaghackrecip = 0;
 char *mailhost;
-char *mailuser;
+const char *mailuser;
 int mailusertokentype;
 char *mailrhost;
-char *mailruser;
+const char *mailruser;
 
 stralloc control_idhost = {0};
 stralloc control_defaultdomain = {0};
@@ -53,9 +54,9 @@
 int flagqueue;
 struct qmail qqt;
 
-void put(s,len) char *s; int len;
+void put(const char *s, unsigned int len)
 { if (flagqueue) qmail_put(&qqt,s,len); else substdio_put(subfdout,s,len); }
-void puts(s) char *s; { put(s,str_len(s)); }
+void putstr(const char *s) { put(s,str_len(s)); }
 
 void perm() { _exit(100); }
 void temp() { _exit(111); }
@@ -90,13 +91,13 @@
 
 void exitnicely()
 {
- char *qqx;
+ const char *qqx;
 
  if (!flagqueue) substdio_flush(subfdout);
 
  if (flagqueue)
   {
-   int i;
+   unsigned int i;
 
    if (!stralloc_0(&sender)) die_nomem();
    qmail_from(&qqt,sender.s);
@@ -106,7 +107,7 @@
      if (!stralloc_0(&reciplist.sa[i])) die_nomem();
      qmail_to(&qqt,reciplist.sa[i].s);
     }
-   if (flagrh)
+   if (flagrh) {
      if (flagresent)
        for (i = 0;i < hrrlist.len;++i)
 	{
@@ -119,9 +120,9 @@
          if (!stralloc_0(&hrlist.sa[i])) die_nomem();
 	 qmail_to(&qqt,hrlist.sa[i].s);
 	}
-
+   }
    qqx = qmail_close(&qqt);
-   if (*qqx)
+   if (*qqx) {
      if (*qqx == 'D') {
        substdio_puts(subfderr,"qmail-inject: fatal: ");
        substdio_puts(subfderr,qqx + 1);
@@ -136,6 +137,7 @@
        substdio_flush(subfderr);
        temp();
      }
+   }
   }
 
  _exit(0);
@@ -152,7 +154,7 @@
 
 void savedh_print()
 {
- int i;
+ unsigned int i;
 
  for (i = 0;i < savedh.len;++i)
    put(savedh.sa[i].s,savedh.sa[i].len);
@@ -177,7 +179,7 @@
 void rwextraat(addr)
 token822_alloc *addr;
 {
- int i;
+ unsigned int i;
  if (addr->t[0].type == TOKEN822_AT)
   {
    --addr->len;
@@ -189,7 +191,7 @@
 void rwextradot(addr)
 token822_alloc *addr;
 {
- int i;
+ unsigned int i;
  if (addr->t[0].type == TOKEN822_DOT)
   {
    --addr->len;
@@ -201,17 +203,17 @@
 void rwnoat(addr)
 token822_alloc *addr;
 {
- int i;
- int shift;
+ unsigned int i;
+ unsigned int shift;
 
  for (i = 0;i < addr->len;++i)
    if (addr->t[i].type == TOKEN822_AT)
      return;
  shift = defaulthost.len;
  if (!token822_readyplus(addr,shift)) die_nomem();
- for (i = addr->len - 1;i >= 0;--i)
-   addr->t[i + shift] = addr->t[i];
  addr->len += shift;
+ for (i = addr->len - 1;i >= shift;--i)
+   addr->t[i] = addr->t[i - shift];
  for (i = 0;i < shift;++i)
    addr->t[i] = defaulthost.t[shift - 1 - i];
 }
@@ -219,8 +221,8 @@
 void rwnodot(addr)
 token822_alloc *addr;
 {
- int i;
- int shift;
+ unsigned int i;
+ unsigned int shift;
  for (i = 0;i < addr->len;++i)
   {
    if (addr->t[i].type == TOKEN822_DOT)
@@ -237,9 +239,9 @@
   }
  shift = defaultdomain.len;
  if (!token822_readyplus(addr,shift)) die_nomem();
- for (i = addr->len - 1;i >= 0;--i)
-   addr->t[i + shift] = addr->t[i];
  addr->len += shift;
+ for (i = addr->len - 1;i >= shift;--i)
+   addr->t[i] = addr->t[i - shift];
  for (i = 0;i < shift;++i)
    addr->t[i] = defaultdomain.t[shift - 1 - i];
 }
@@ -247,8 +249,8 @@
 void rwplus(addr)
 token822_alloc *addr;
 {
- int i;
- int shift;
+ unsigned int i;
+ unsigned int shift;
 
  if (addr->t[0].type != TOKEN822_ATOM) return;
  if (!addr->t[0].slen) return;
@@ -258,9 +260,9 @@
 
  shift = plusdomain.len;
  if (!token822_readyplus(addr,shift)) die_nomem();
- for (i = addr->len - 1;i >= 0;--i)
-   addr->t[i + shift] = addr->t[i];
  addr->len += shift;
+ for (i = addr->len - 1;i >= shift;--i)
+   addr->t[i] = addr->t[i - shift];
  for (i = 0;i < shift;++i)
    addr->t[i] = plusdomain.t[shift - 1 - i];
 }
@@ -536,7 +538,7 @@
 
 void finishmft()
 {
-  int i;
+  unsigned int i;
   static stralloc sa = {0};
   static stralloc sa2 = {0};
 
@@ -549,16 +551,16 @@
 
   if (i == tocclist.len) return;
 
-  puts("Mail-Followup-To: ");
+  putstr("Mail-Followup-To: ");
   i = tocclist.len;
   while (i--) {
     if (!stralloc_copy(&sa,&tocclist.sa[i])) die_nomem();
     if (!stralloc_0(&sa)) die_nomem();
     if (!quote2(&sa2,sa.s)) die_nomem();
     put(sa2.s,sa2.len);
-    if (i) puts(",\n  ");
+    if (i) putstr(",\n  ");
   }
-  puts("\n");
+  putstr("\n");
 }
 
 void finishheader()
@@ -580,9 +582,9 @@
    if (!stralloc_0(&sa)) die_nomem();
    if (!quote2(&sa2,sa.s)) die_nomem();
 
-   puts("Return-Path: <");
+   putstr("Return-Path: <");
    put(sa2.s,sa2.len);
-   puts(">\n");
+   putstr(">\n");
   }
 
  /* could check at this point whether there are any recipients */
@@ -594,23 +596,23 @@
    if (!htypeseen[H_R_DATE])
     {
      if (!newfield_datemake(starttime)) die_nomem();
-     puts("Resent-");
+     putstr("Resent-");
      put(newfield_date.s,newfield_date.len);
     }
    if (!htypeseen[H_R_MESSAGEID])
     {
      if (!newfield_msgidmake(control_idhost.s,control_idhost.len,starttime)) die_nomem();
-     puts("Resent-");
+     putstr("Resent-");
      put(newfield_msgid.s,newfield_msgid.len);
     }
    if (!htypeseen[H_R_FROM])
     {
      defaultfrommake();
-     puts("Resent-");
+     putstr("Resent-");
      put(defaultfrom.s,defaultfrom.len);
     }
    if (!htypeseen[H_R_TO] && !htypeseen[H_R_CC])
-     puts("Resent-Cc: recipient list not shown: ;\n");
+     putstr("Resent-Cc: recipient list not shown: ;\n");
   }
  else
   {
@@ -630,7 +632,7 @@
      put(defaultfrom.s,defaultfrom.len);
     }
    if (!htypeseen[H_TO] && !htypeseen[H_CC])
-     puts("Cc: recipient list not shown: ;\n");
+     putstr("Cc: recipient list not shown: ;\n");
    finishmft();
   }
 
@@ -682,11 +684,11 @@
 #define RECIP_HEADER 3
 #define RECIP_AH 4
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
- int i;
+ unsigned int i;
  int opt;
  int recipstrategy;
 
@@ -770,4 +772,6 @@
  if (headerbody(subfdin,doheaderfield,finishheader,dobody) == -1)
    die_read();
  exitnicely();
+ /* NOTREACHED */
+ return 0;
 }
diff -ruN qmail-1.03-orig/qmail-ldap.h qmail-1.03-ldap-20060201-orig/qmail-ldap.h
--- qmail-1.03-orig/qmail-ldap.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-ldap.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,190 @@
+/*
+ * Copyright (c) 1999-2004 Andre Oppermann, Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef _QMAIL_LDAP_H_
+#define _QMAIL_LDAP_H_
+
+/* this is the "catch all" string
+ * ATTN: escape the string correctly, remember
+ * '(', ')', '\', and '*' have to be escaped with '\'
+ */
+#define LDAP_CATCH_ALL "catchall"
+
+/* triger level for quotawarning (0-100) */
+#define QUOTA_WARNING_LEVEL 70
+
+/* reply subject for mails without subjects. */
+#define REPLY_SUBJ "Your Mail"
+/* timeout for one delivery per sender */
+#define REPLY_TIMEOUT 1209600 /* 1 Week */
+/* default content type (don't forget the '\n' at the end) */
+#define REPLY_CT "text/plain; charset=utf-8\n"
+/* default content transfer encoding (don't forget the '\n' at the end) */
+#define REPLY_CTE "8bit\n"
+
+/* the maximum and minimum uid allowed */
+#define UID_MIN 100
+#define UID_MAX 65535
+
+/* the maximum and minimum gid allowed */
+#define GID_MIN 100
+#define GID_MAX 65535
+
+/* if the sanitycheck function should be less restricted for
+ * program pathes, this means especially that most special chars
+ * of the shell are allowed (like &, &, ;, and <,|,>)
+ * You should know what you are doing when disallowing this  */
+/* 1 = restriced sanitycheck; 0 = less restriced sanitycheck */
+#define RESTRICT_PROG 1
+
+/* ALIASDEVNULL replacement for the std. aliasempty for user with
+ * neither homeDirectory nor mailMessageStore defined */
+#define ALIASDEVNULL "|echo \"Unable to deliver mail: account incorrectly configured. (#5.3.5)\"; exit 100"
+/* just echo a warning to notify the user and exit 100.
+ * It's up to the reader to write a simple script with
+ * postmaster notification. */
+
+/* Default ldap search timeout. In seconds */
+#define	QLDAP_TIMEOUT		30
+
+/* This needs DASH_EXT option.
+ * Limit dash ext to the first DASH_EXT_LEVELS extensions.
+ * Search only for (DASH_EXT_LEVELS = 4):
+ * a-b-c-d-e-f-g-...@foobar.com
+ * a-b-c-d-catchall@foobar.com
+ * a-b-c-catchall@foobar.com
+ * a-b-catchall@foobar.com
+ * a-catchall@foobar.com
+ * catchall@foobar.com
+ */
+#define DASH_EXT_LEVELS 4
+
+/*********************************************************************
+        ldap variables used in qmail-lspawn and auth_*
+*********************************************************************/
+#define LDAP_MAIL		"mail"
+#define LDAP_MAILALTERNATE	"mailAlternateAddress"
+#define LDAP_QMAILUID		"qmailUID"
+#define LDAP_QMAILGID		"qmailGID"
+#define LDAP_MAILSTORE		"mailMessageStore"
+#define LDAP_HOMEDIR		"homeDirectory"
+#define LDAP_QUOTA		"mailQuota"
+#define LDAP_QUOTA_SIZE		"mailQuotaSize"
+#define LDAP_QUOTA_COUNT	"mailQuotaCount"
+#define LDAP_MAXMSIZE		"mailSizeMax"
+#define LDAP_FORWARDS		"mailForwardingAddress"
+#define LDAP_PROGRAM		"deliveryProgramPath"
+#define LDAP_MAILHOST		"mailHost"
+#define LDAP_MODE		"deliveryMode"
+#define LDAP_REPLYTEXT		"mailReplyText"
+#define LDAP_DOTMODE		"qmailDotMode"
+#define LDAP_UID		"uid"
+#define LDAP_PASSWD		"userPassword"
+#define LDAP_OBJECTCLASS	"objectClass"
+#define LDAP_ISACTIVE		"accountStatus"
+#define LDAP_PURGE		"qmailAccountPurge"
+
+#define DOTMODE_LDAPONLY 	"ldaponly"
+#define DOTMODE_LDAPWITHPROG	"ldapwithprog"
+#define DOTMODE_DOTONLY		"dotonly"
+#define DOTMODE_BOTH		"both"
+#define DOTMODE_NONE		"none"
+
+#define MODE_FONLY		"forwardonly"
+#define MODE_NOFORWARD		"noforward"
+#define MODE_NOMBOX		"nombox"
+#define MODE_NOLOCAL		"nolocal"
+#define MODE_NOPROG		"noprogram"
+#define MODE_REPLY		"reply"
+/* these are silently ignored */
+#define MODE_LOCAL		"local"
+#define MODE_FORWARD		"forward"
+#define MODE_PROG		"program"
+#define MODE_NOREPLY		"noreply"
+
+#define ISACTIVE_BOUNCE		"disabled"
+#define ISACTIVE_DELETE		"deleted"
+#define ISACTIVE_NOACCESS	"noaccess"
+#define ISACTIVE_ACTIVE		"active"
+
+/*********************************************************************
+        ldap variables used in qmail-group
+*********************************************************************/
+#define LDAP_GROUPOBJECTCLASS	"qmailGroup"
+#define LDAP_GROUPMEMONLY	"membersonly"
+#define LDAP_GROUPCONFIRM	"senderconfirm"
+#define LDAP_GROUPCONFRIMTEXT	"confirmtext"
+#define LDAP_GROUPMODERATTEXT	"moderatortext"
+#define LDAP_GROUPMODERATDN	"dnmoderator"
+#define LDAP_GROUPMODERAT822	"rfc822moderator"
+#define LDAP_GROUPMEMBERDN	"dnmember"
+#define LDAP_GROUPMEMBER822	"rfc822member"
+#define LDAP_GROUPMEMBERFILTER	"filtermember"
+#define LDAP_GROUPSENDERDN	"dnsender"
+#define LDAP_GROUPSENDER822	"rfc822sender"
+#define LDAP_GROUPSENDERFILTER	"filtersender"
+#define LDAP_GROUPBOUNCEADMIN	"bounceadmin"
+
+
+/*********************************************************************
+                 normaly you can stop editing here
+*********************************************************************/
+/* the same values as ints */
+#define STATUS_DELETE		3
+#define STATUS_BOUNCE		2
+#define STATUS_NOACCESS		1
+#define STATUS_OK 		0
+#define STATUS_UNDEF 		-1
+
+/* environment variables used between qmail-lspan and qmail-local
+ * and some other tools
+ */
+#define ENV_HOMEDIRMAKE		"QLDAPAUTOHOMEDIRMAKE"
+
+#define ENV_QUOTA		"MAILDIRQUOTA"
+#define ENV_QUOTAWARNING 	"QMAILQUOTAWARNING"
+
+#define ENV_DOTMODE		"QMAILDOTMODE"
+#define ENV_MODE 		"QMAILMODE"
+#define ENV_REPLYTEXT		"QMAILREPLYTEXT"
+#define ENV_FORWARDS		"QMAILFORWARDS"
+#define ENV_PROGRAM		"QMAILDELIVERYPROGRAM"
+
+#define ENV_GROUP		"QLDAPGROUP"
+
+/* qmail-local.c only */
+#define DO_LDAP 	0x01
+#define DO_DOT  	0x02
+#define DO_BOTH 	(DO_LDAP | DO_DOT)
+
+#endif
diff -ruN qmail-1.03-orig/qmail-ldaplookup.c qmail-1.03-ldap-20060201-orig/qmail-ldaplookup.c
--- qmail-1.03-orig/qmail-ldaplookup.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-ldaplookup.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,548 @@
+/*
+ * Copyright (c) 2000-2004 Andre Oppermann, Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <pwd.h>
+#include <unistd.h>
+
+#include "alloc.h"
+#include "auto_usera.h"
+#include "byte.h"
+#include "case.h"
+#include "env.h"
+#include "error.h"
+#include "localdelivery.h"
+#include "output.h"
+#include "passwd.h"
+#include "qldap.h"
+#include "qldap-cluster.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qmail-ldap.h"
+#include "read-ctrl.h"
+#include "scan.h"
+#include "sgetopt.h"
+#include "str.h"
+#include "stralloc.h"
+#include "strerr.h"
+#include "subfd.h"
+#include "substdio.h"
+#ifdef AUTOHOMEDIRMAKE
+#include "dirmaker.h"
+#endif
+
+#define FATAL "qmail-ldaplookup: fatal: "
+#define WARN "qmail-ldaplookup: warning: "
+
+void
+temp_nomem(void)
+{
+        strerr_die2x(111, FATAL, "Out of memory.");
+}
+
+void
+usage(void) 
+{
+	output(subfderr,
+	    "usage:"
+	    "\t%s [-d level] [-D binddn -w passwd] -u uid [-p passwd]\n"
+	    "\t%s [-d level] [-D binddn -w passwd] -m mail\n"
+	    "\t%s [-d level] [-D binddn -w passwd] -f ldapfilter\n",
+	    optprogname, optprogname, optprogname, optprogname);
+	output(subfderr, "options:\n"
+	    "\t-d level \tsets log-level to level\n"
+	    "\t-u uid   \tsearch for user id uid (pop3/imap lookup)\n"
+	    "\t-p passwd\tpassword for user id lookups (only by root)\n"
+	    "\t-m mail  \tlookup the mailaddress\n"
+	    "\t-D binddn\tbind DN\n"
+	    "\t-w passwd\tbind password\n");
+	_exit(1);
+}
+
+void fail(qldap *, const char *, int);
+void unescape(char *, stralloc *);
+
+
+ctrlfunc ctrls[] = {
+  qldap_ctrl_trylogin,
+  qldap_ctrl_generic,
+  localdelivery_init,
+#ifdef QLDAP_CLUSTER
+  cluster_init,
+#endif
+#ifdef AUTOHOMEDIRMAKE
+  dirmaker_init,
+#endif
+  0
+};
+
+stralloc dn = {0};
+stralloc foo = {0};
+stralloc bar = {0};
+
+int main(int argc, char **argv)
+{
+	enum { unset, uid, mail, filter } mode = unset;
+	qldap	*q, *qpw;
+	struct passwd *pw;
+	char	*passwd = 0, *value = 0;
+	char	*bindpw = 0, *binddn = 0;
+	char	*f, *s;
+	int	opt, r, done, status, id;
+	unsigned int j, slen;
+	unsigned long size, count, maxsize;
+	
+	const char *attrs[] = { LDAP_MAIL,
+				LDAP_MAILALTERNATE,
+				LDAP_UID,
+				LDAP_QMAILUID,
+				LDAP_QMAILGID,
+				LDAP_ISACTIVE,
+				LDAP_MAILHOST,
+				LDAP_MAILSTORE,
+				LDAP_HOMEDIR,
+				LDAP_QUOTA_SIZE,
+				LDAP_QUOTA_COUNT,
+				LDAP_FORWARDS,
+				LDAP_PROGRAM,
+				LDAP_MODE,
+				LDAP_REPLYTEXT,
+				LDAP_DOTMODE,
+				LDAP_MAXMSIZE,
+				LDAP_OBJECTCLASS,
+#if 0
+				LDAP_GROUPCONFIRM,
+				LDAP_GROUPMEMONLY,
+				LDAP_GROUPCONFRIMTEXT,
+				LDAP_GROUPMODERATTEXT,
+				LDAP_GROUPMODERATDN,
+				LDAP_GROUPMODERAT822,
+				LDAP_GROUPMEMBERDN,
+				LDAP_GROUPMEMBER822,
+				LDAP_GROUPMEMBERFILTER,
+#endif
+				LDAP_PASSWD,
+				0};
+
+	while ((opt = getopt(argc, argv, "d:D:u:m:p:f:w:")) != opteof)
+		switch (opt) {
+		case 'd':
+			if (env_put2("LOGLEVEL", optarg) == 0)
+				strerr_die2sys(1, FATAL, "setting loglevel: ");
+			break;
+		case 'D':
+			binddn = optarg;
+			break;
+		case 'u':
+			if (value != 0)
+				usage();
+			value = optarg;
+			mode = uid;
+			break;
+		case 'm':
+			if (value != 0)
+				usage();
+			value = optarg;
+			mode = mail;
+			break;
+		case 'f':
+			if (value != 0)
+				usage();
+			value = optarg;
+			mode = filter;
+			break;
+		case 'p':
+			if (geteuid() != 0)
+				strerr_die2x(1, FATAL,
+				    "only the superuser may comapre passwords");
+			passwd = optarg;
+			break;
+		case 'w':
+			bindpw = optarg;
+			break;
+		default:
+			usage();
+		}
+	if (argc != optind) usage();
+	if (bindpw && !binddn) usage();
+	
+	log_init(STDERR, -1, 0);
+
+	if (read_controls(ctrls) != 0)
+		strerr_die2sys(111, FATAL, "unable to read controls: ");
+	
+	q = qldap_new();
+	if (q == 0)
+		strerr_die2sys(111, FATAL, "qldap_new failed: ");
+	qpw = qldap_new();
+	if (qpw == 0)
+		strerr_die2sys(111, FATAL, "qldap_new failed: ");
+	
+	r = qldap_open(q);
+	if (r != OK) fail(q, "qldap_open", r);
+	r = qldap_open(qpw);
+	if (r != OK) fail(qpw, "qldap_open", r);
+	r = qldap_bind(q, binddn, bindpw);
+	if (r != OK) fail(q, "qldap_bind", r);
+
+	if (passwd == 0 || mode != uid || qldap_need_rebind() != 0)
+		attrs[sizeof(attrs)/4 - 2] = 0; /* password */
+	done = 0;
+	f = 0;
+	do {
+		switch (mode) {
+		case mail:
+			f = filter_mail(value, &done);
+			if (value == 0)
+				strerr_die2sys(1, FATAL, "building filter: ");
+			break;
+		case uid:
+			f = filter_uid(value);
+			done = 1;
+			if (value == 0)
+				strerr_die2sys(1, FATAL, "building filter: ");
+			break;
+		case filter:
+			f = value;
+			break;
+		default:
+			usage();
+		}
+		output(subfdout, "Searching ldap for: %s\nunder dn: %s\n",
+		    f, qldap_basedn());
+		r = qldap_filter(q, f, attrs, qldap_basedn(), SCOPE_SUBTREE);
+		if (r != OK) fail(q, "qldap_filter", r);
+
+		r = qldap_count(q);
+		switch (r) {
+		case -1:
+			fail(q, "qldap_count", FAILED);
+		case 0:
+			output(subfdout, "No entries found.\n");
+			qldap_free(q);
+			/* TODO hook for local lookups. */
+			return 0;
+		case 1:
+			output(subfdout, "Found %i entry:\n", r);
+			break;
+		default:
+			output(subfdout, "Found %i entries:\n", r);
+			if (mode == uid || mode == uid) {
+				output(subfdout,
+				    "Uh-oh: multiple entries found but "
+				    "should be unique!\n");
+				passwd = 0;
+			}
+			break;
+		}
+		output(subfdout, "\n");
+	} while (r == 0 && !done);
+
+	r = qldap_first(q);
+	if (r != OK) fail(q, "qldap_first", r);;
+	do {
+		r = qldap_get_dn(q, &dn);
+		if (r != OK) fail(q, "qldap_get_dn", r);
+		output(subfdout, "dn: %s\n"
+		    "-------------------------------------------------------\n",
+		    dn.s);
+		
+		r = qldap_get_attr(q, LDAP_OBJECTCLASS, &foo, MULTI_VALUE);
+		if (r != OK) fail(q, "qldap_get_attr(" LDAP_OBJECTCLASS ")", r);
+		unescape(foo.s, &bar);
+		s = bar.s;
+		slen = bar.len-1;
+		for(;;) {
+			output(subfdout, "%s: %s\n",LDAP_OBJECTCLASS ,s);
+			j = byte_chr(s,slen,0);
+			if (j++ >= slen) break;
+			s += j; slen -= j;
+		}
+		
+		r = qldap_get_attr(q, LDAP_MAIL, &foo, SINGLE_VALUE);
+		if (r != OK) fail(q, "qldap_get_attr(" LDAP_MAIL ")", r);
+		output(subfdout, "%s: %s\n", LDAP_MAIL, foo.s);
+
+		r = qldap_get_attr(q, LDAP_MAILALTERNATE, &foo, MULTI_VALUE);
+		if (r != OK && r != NOSUCH)
+			fail(q, "qldap_get_attr(" LDAP_MAILALTERNATE ")", r);
+		if (r == OK) {
+			unescape(foo.s, &bar);
+			s = bar.s;
+			slen = bar.len-1;
+			for(;;) {
+				output(subfdout, "%s: %s\n",
+				    LDAP_MAILALTERNATE, s);
+				j = byte_chr(s,slen,0);
+				if (j++ >= slen) break;
+				s += j; slen -= j;
+			}
+		}
+		
+		r = qldap_get_user(q, &foo);
+		if (r != OK && r != NOSUCH) fail(q, "qldap_get_user", r);
+		if (r == OK)
+			output(subfdout, "%s: %s\n", LDAP_UID, foo.s);
+		else
+			output(subfdout, "%s: undefined "
+			    "(forward only account required)\n", LDAP_UID);
+
+		r = qldap_get_status(q, &status);
+		if (r != OK) fail(q, "qldap_get_status", r);
+		switch (status) {
+		case STATUS_BOUNCE:
+			output(subfdout, "%s: %s\n",
+			    LDAP_ISACTIVE, ISACTIVE_BOUNCE);
+			break;
+		case STATUS_NOACCESS:
+			output(subfdout, "%s: %s\n",
+			    LDAP_ISACTIVE, ISACTIVE_NOACCESS);
+			break;
+		case STATUS_OK:
+			output(subfdout, "%s: %s\n",
+			    LDAP_ISACTIVE, ISACTIVE_ACTIVE);
+			break;
+		case STATUS_UNDEF:
+			output(subfdout, "%s: %s\n", LDAP_ISACTIVE,
+			    "undefined -> active");
+			break;
+		default:
+			strerr_warn2(WARN,
+			    "qldap_get_status returned unknown status", 0);
+		}
+		
+		r = qldap_get_attr(q, LDAP_MAILHOST, &foo, SINGLE_VALUE);
+		if (r != OK && r != NOSUCH)
+			fail(q, "qldap_get_attr(" LDAP_MAILHOST ")", r);
+		if (r == OK) {
+			output(subfdout, "%s: %s\n", LDAP_MAILHOST, foo.s);
+			/*
+			 * TODO we could check if we are in cluster mode and 
+			 * if we would redirect to a differnet host
+			 */
+		} else
+			output(subfdout, "%s: undefined\n", LDAP_MAILHOST);
+
+		/* get the path of the maildir or mbox */
+		r = qldap_get_mailstore(q, &foo, &bar);
+		switch (r) {
+		case OK:
+			output(subfdout, "homeDirectory: %s\n", foo.s);
+			if (bar.len > 0)
+				output(subfdout, "aliasEmpty: %s\n", bar.s);
+			else
+				output(subfdout, "aliasEmpty: using default\n");
+			break;
+		case NEEDED:
+			output(subfdout,
+			    "forward only delivery via alias user\n");
+			pw = getpwnam(auto_usera);
+			if (!pw)
+				strerr_die4x(100, FATAL,
+				    "Aiiieeeee, now alias user '",
+				    auto_usera, "'found in /etc/passwd.");
+			output(subfdout, "alias user: %s\n", pw->pw_name);
+			output(subfdout, "alias user uid: %i\n", pw->pw_uid);
+			output(subfdout, "alias user gid: %i\n", pw->pw_gid);
+			output(subfdout, "alias user home: %s\n", pw->pw_dir);
+			output(subfdout, "alias user aliasempty: %s\n",
+			    ALIASDEVNULL);
+			/* get the forwarding addresses */
+			r = qldap_get_attr(q, LDAP_FORWARDS, &foo, MULTI_VALUE);
+			if (r != OK)
+				fail(q, "qldap_get_attr("
+				    LDAP_FORWARDS ") for forward only user", r);
+			unescape(foo.s, &bar);
+			s = bar.s;
+			slen = bar.len-1;
+			for(;;) {
+				output(subfdout, "%s: %s\n", LDAP_FORWARDS, s);
+				j = byte_chr(s,slen,0);
+				if (j++ >= slen) break;
+				s += j; slen -= j;
+			}
+			goto next;
+		default:
+			fail(q, "qldap_get_mailstore", r);
+		}
+		
+		r = qldap_get_dotmode(q, &foo);
+		if (r != OK) fail(q, "qldap_get_dotmode", r);
+		output(subfdout, "%s: %s\n", LDAP_DOTMODE, foo.s);
+
+		r = qldap_get_uid(q, &id);
+		if (r != OK) fail(q, "qldap_get_uid", r);
+		output(subfdout, "%s: %i\n", LDAP_QMAILUID, id);
+		
+		r = qldap_get_gid(q, &id);
+		if (r != OK) fail(q, "qldap_get_gid", r);
+		output(subfdout, "%s: %i\n", LDAP_QMAILGID, id);
+		
+		r = qldap_get_quota(q, &size, &count, &maxsize);
+		if (r != OK) fail(q, "qldap_get_quota", r);
+		output(subfdout, "%s: %u%s\n", LDAP_QUOTA_SIZE, size,
+		    size==0?" (unlimited)":"");
+		output(subfdout, "%s: %u%s\n", LDAP_QUOTA_COUNT, count,
+		    count==0?" (unlimited)":"");
+		output(subfdout, "%s: %u%s\n", LDAP_MAXMSIZE, maxsize,
+		    maxsize==0?" (unlimited)":"");
+
+		r = qldap_get_attr(q, LDAP_MODE, &foo, MULTI_VALUE);
+		if (r != OK && r != NOSUCH)
+			fail(q, "qldap_get_attr(" LDAP_MODE ")", r);
+		if (r == OK) {
+			unescape(foo.s, &bar);
+			s = bar.s;
+			slen = bar.len-1;
+			for(;;) {
+				if (case_diffs(MODE_FORWARD, s) &&
+				    case_diffs(MODE_REPLY, s) &&
+				    case_diffs(MODE_NOLOCAL, s) &&
+				    case_diffs(MODE_NOMBOX, s) &&
+				    case_diffs(MODE_NOFORWARD, s) &&
+				    case_diffs(MODE_NOPROG, s) &&
+				    case_diffs(MODE_LOCAL, s) &&
+				    case_diffs(MODE_FORWARD, s) &&
+				    case_diffs(MODE_PROG, s) &&
+				    case_diffs(MODE_NOREPLY, s))
+					strerr_warn4(WARN,
+					    "undefined mail delivery mode: ",
+					    s," (ignored).", 0);
+				else if (!case_diffs(MODE_FORWARD, s))
+					strerr_warn4(WARN,
+					    "mail delivery mode: ",
+					    s," should not be used "
+					    "(used internally).", 0);
+				output(subfdout, "%s: %s\n", LDAP_MODE, s);
+				j = byte_chr(s,slen,0);
+				if (j++ >= slen) break;
+				s += j; slen -= j;
+			}
+		}
+
+		r = qldap_get_attr(q, LDAP_FORWARDS, &foo, MULTI_VALUE);
+		if (r != OK && r != NOSUCH)
+			fail(q, "qldap_get_attr(" LDAP_FORWARDS ")", r);
+		if (r == OK) {
+			unescape(foo.s, &bar);
+			s = bar.s;
+			slen = bar.len-1;
+			for(;;) {
+				output(subfdout, "%s: %s\n", LDAP_FORWARDS, s);
+				j = byte_chr(s,slen,0);
+				if (j++ >= slen) break;
+				s += j; slen -= j;
+			}
+		}
+
+		r = qldap_get_attr(q, LDAP_PROGRAM, &foo, MULTI_VALUE);
+		if (r != OK && r != NOSUCH)
+			fail(q, "qldap_get_attr(" LDAP_PROGRAM ")", r);
+		if (r == OK) {
+			unescape(foo.s, &bar);
+			s = bar.s;
+			slen = bar.len-1;
+			for(;;) {
+				output(subfdout, "%s: %s\n", LDAP_PROGRAM, s);
+				j = byte_chr(s,slen,0);
+				if (j++ >= slen) break;
+				s += j; slen -= j;
+			}
+		}
+
+		r = qldap_get_attr(q, LDAP_REPLYTEXT, &foo, SINGLE_VALUE);
+		if (r != OK && r != NOSUCH)
+			fail(q, "qldap_get_attr(" LDAP_REPLYTEXT ")", r);
+		if (r == OK)
+			output(subfdout, "%s:\n=== begin ===\n%s\n"
+			    "=== end ===\n", LDAP_REPLYTEXT, foo.s);
+		else
+			output(subfdout, "%s: undefined\n", LDAP_REPLYTEXT);
+
+		if (mode == uid && passwd != 0) {
+			if (qldap_need_rebind() == 0) {
+				r = qldap_get_attr(q, LDAP_PASSWD,
+				    &foo, SINGLE_VALUE);
+				if (r != OK) fail(q, "qldap_get_attr("
+				    LDAP_PASSWD ")", r);
+				r = cmp_passwd(passwd, foo.s);
+			} else {
+				r = qldap_rebind(qpw, dn.s, passwd);
+				switch (r) {
+				case OK:
+					r = OK;
+					break;
+				case LDAP_BIND_AUTH:
+					r = BADPASS;
+					break;
+				default:
+					break;
+				}
+			}
+			output(subfdout, "\nPASSWORD COMPARE was %s.\n",
+			    r == OK?"successful":"NOT successful");
+			if (r != OK)
+				output(subfdout, "\terror was: %s\n",
+				    qldap_err_str(r));
+		}
+
+next:
+		r = qldap_next(q);
+		output(subfdout, "\n\n");
+	} while (r == OK);
+	if (r != NOSUCH) fail(q, "qldap_next", r);
+	qldap_free(q);
+	return 0;
+}
+
+void
+fail(qldap *q, const char *f, int r)
+{
+	qldap_free(q);
+	strerr_die4x(111, FATAL, f ,": ", qldap_err_str(r));
+}
+
+void
+unescape(char *s, stralloc *t)
+{
+  if (!stralloc_copys(t, "")) temp_nomem();
+  do {
+    if (s[0] == '\\' && s[1] == ':') s++;
+    else if (s[0] == ':') {
+      if (!stralloc_0(t)) temp_nomem();
+      continue;
+    }
+    if (!stralloc_append(t, s)) temp_nomem();
+  } while (*s++);
+}
+
